int LED_R = 12; // LED ROJO conectado en el PIN 12
int LED_IR = 11; // LED IR conectado en el PIN 11
int SENSOR_R = 6; // SENSOR rojo conectado en el PIN analogico 6
int SENSOR_IR = 7; // SENSOR infrarrojo conectado en el PIN analogico 7
int SENSOR_VALOR_R = 0; // Lectura del sensor para luz roja encendida
int SENSOR_VALOR_IR = 0; // Lectura del sensor para luz infrarroja encendida
int INTERRUPTOR_R = 10; // Controla el interruptor rojo por el PIN 10
int INTERRUPTOR_IR = 9; // Controla el interruptor infrarrojo por el PIN 9
int MILISEG = 0; // Contador de milisegundos
void setup() {
pinMode (LED_R, OUTPUT); // Configuración del PIN LED_R como salida
pinMode (LED_IR, OUTPUT); // Configuración del PIN LED_IR como salida
pinMode (SENSOR_R, INPUT); // Configuración del PIN SENSOR rojo como entrada
pinMode (SENSOR_IR, INPUT); // Configuración del PIN SENSOR infrarrojo como entrada
pinMode (INTERRUPTOR_R, OUTPUT); // PIN INTERRUPTOR_R como salida
pinMode (INTERRUPTOR_IR, OUTPUT); // PIN INTERRUPTOR_IR como salida
analogReference (DEFAULT); // Configuración de la tensión de referencia por defecto (5 V)
Serial.begin (9600); // Configuración para la transmisión de los datos por el puerto serie
}
void loop() {
// Encendido alterno de los LEDs rojo e infrorrojo
digitalWrite (LED_R, HIGH); // Encendido del LED rojo
delayMicroseconds (10); // Espera para encendido completo del LED
digitalWrite (INTERRUPTOR_R, HIGH); // Cierre del interruptor rojo
delayMicroseconds (460); // Espera para estabilización de señal
SENSOR_VALOR_R = analogRead (SENSOR_R); // Lectura del pin del sensor rojo
digitalWrite (INTERRUPTOR_R, LOW); // Apertura del interruptor rojo
delayMicroseconds (10); // Espera para apertura completa del interruptor
digitalWrite (LED_R, LOW); // Apagado del LED rojo
delayMicroseconds (20);
digitalWrite (LED_IR, HIGH); // Encendido del LED infrarrojo
delayMicroseconds (10); // Espera para encendido completo del LED
digitalWrite (INTERRUPTOR_IR, HIGH); // Cierre del interruptor infrarrojo
delayMicroseconds (460); // Espera para estabilización de señal
SENSOR_VALOR_IR = analogRead (SENSOR_IR); // Lectura del pin del sensor infrarrojo
digitalWrite (INTERRUPTOR_IR, LOW); // Apertura del interruptor infrarrojo
delayMicroseconds (10); // Espera para apertura completa del interruptor
digitalWrite (LED_IR, LOW); // Apagado del LED infrarrojo
delayMicroseconds (20);
// El ciclo completo anterior tarta 1 milisegundo, cada 20 milisegundos enviamos las muestras
MILISEG = MILISEG + 1; // Incrementa en 1 los milisegundos transcurridos
if (MILISEG == 20) // Tras 20 milisengudos imprimimos las muestras de ambas señales
{
Serial.print (SENSOR_VALOR_R);
Serial.print (",");
Serial.println (SENSOR_VALOR_IR);
MILISEG = 0;
}
}
